<template>
  <GManageTable
    :card="card"
    :level="level"
    :i18n-base="i18nBase"
    v-bind="$attrs"
    :headers="headers"
    use-wrapper
    :items="value.usedMethod"
    :get-new-item="getNewItem"
    :optional="optional"
    :wiki-entry="wikiEntry"
    @create="create"
    @edit="edit"
    @remove="remove"
    @deleteElement="$emit('delete')"
  >
    <template #form="{ item, updateAvailableElements }">
      <UsedMethod
        v-model="item.value"
        :update-available-elements="updateAvailableElements"
      />
    </template>

    <template #[`item.name`]="{ item }">
      {{ getForCurrentLocale(item.name) }}
    </template>
    <template #[`item.description`]="{ item }">
      <div class="text-truncate default-max-width">
        {{ getForCurrentLocale(item.description) }}
      </div>
    </template>
  </GManageTable>
</template>

<script>
import { UsedMethodType, RichContentType } from "@d-ptb/dcc-js";
import { removeFromArray } from "assets/util/general";
import { validatableMixin } from "../../Mixins/validatableMixin";
import GManageTable from "~/components/App/Common/ManagementTable/GManageTable";
import { localizationMixin } from "~/components/Mixins/localizationMixin";
import UsedMethod from "~/components/DCC/Common/UsedMethod.vue";

export default {
  name: "UsedMethodList",
  components: {
    UsedMethod,
    GManageTable,
  },
  mixins: [validatableMixin, localizationMixin],
  props: {
    value: Object,
    card: {
      type: Boolean,
      default: true,
    },
    level: String,
    i18nBase: {
      type: String,
      default: "dcc.common.usedMethodListType",
    },
    optional: {
      type: Boolean,
      default: false,
    },
    wikiEntry: {
      type: String,
      default: "usedMethods",
    },
  },
  data() {
    return {
      headers: [
        {
          text: this.$t("dcc.common.attributes.refType"),
          value: "_attr.refType",
        },
        {
          text: this.$t("dcc.common.usedMethodListType.name"),
          value: "name",
        },
        {
          text: this.$t("dcc.common.usedMethodListType.description"),
          value: "description",
        },
      ],
    };
  },
  methods: {
    validate() {
      return this.value.usedMethod.length > 0;
    },
    remove(item) {
      removeFromArray(this.value.usedMethod, item);
    },
    getNewItem() {
      return new UsedMethodType();
    },
    create(item) {
      this.value.usedMethod.push(new UsedMethodType(item));
    },
    edit(item, index) {
      this.$set(this.value.usedMethod, index, undefined);
      this.$set(this.value.usedMethod, index, new UsedMethodType(item));
    },
    addRichContent(item) {
      this.$set(item, "description", new RichContentType());
    },
    deleteRichContent(item) {
      confirm(
        this.$t("dcc.common.richContentType.description.confirmRemove")
      ) && this.$delete(item, "description");
    },
  },
};
</script>
